import waba.ui.*;
import waba.fx.*;

/** Possibly the silliest application of all time.
  * Turns the screen black. That's it.
  * @author George Ruban 08/2001 */
public class Mirror extends MainWindow
{
  boolean showText;
  private int lastY;
  private int nextMessage;

  static String[] messages = {

    "Palm Mirror 2.0\n" +
    "(Possibly the silliest application\n" +
    "... known to man.)\n" +
    "WabaJump open source freeware\n\n" +
    "George Ruban, September 2001\n"+
    "http://geocities.com/george_ruban\n\n"+
    "Click again for some Mirror quotes.",

    "\"Mirror, mirror upon the wall,\n" +
    "Who is the fairest fair of all?\"\n\n" +
    "\"O Lady Queen, though fair ye be,\n" +
    "Snow-White is fairer far to see.\"\n\n" +
    "\"Grimm's Fairy Tales\"\n" +
    "L.L.Weedon 1898 translation.",
        
    "The perfect man uses\n"+
    "his mind as a mirror.\n"+
    "It grasps nothing.\nIt regrets nothing.\n" +
    "It receives but does not keep.\n\n"+
    "Chuang Tzu",

    "The face is the mirror of the mind,\n"+
    "and eyes without speaking confess\n"+
    "the secrets of the heart.\n\n" +
    "Saint Jerome (342 AD - 420 AD)",

    "When a man meets catastrophe\n"+
    "on the road, he looks in his purse,\n"+
    "but a woman looks in her mirror.\n\n"+
    "Margaret Turnbull",

    "Men look at themselves in mirrors.\n"+
    "Women look for themselves.\n\n" +
    "Elissa Melamed",
    
    "A man's true wealth is the\n"+
    "good he does in the world.\n"+
    "Beauty is eternity gazing \n"+
    "at itself in a mirror.\n"+
    "But you are eternity\n"+
    "and you are the mirror.\n\n"+
    "Kahlil Gibran, \"The Prophet\""

  };
  
  /** Draws text centered at lastY, moves lastY down. */
  private void centerText(Graphics g, String text)
  {
    FontMetrics fm = getFontMetrics(MainWindow.defaultFont);
    int[] breaks = new int[12]; // no more than this
    int lines = 1;
    int i;
    breaks[0] = -1;
    while((i = text.indexOf('\n', breaks[lines - 1]+1)) > 0)
    {
      // System.out.println(lines + ": " + text.substring(breaks[lines-1]+1, i));
      breaks[lines] = i;
      lines ++;
    }
    
    breaks[lines] = text.length();
    int textHeight = fm.getHeight() + 1;
    int y = (height - textHeight * (lines + 1)) / 2;
    for(i = 0; i< lines; ++i){
      String line = text.substring(breaks[i]+1, breaks[i+1]);
      int textWidth = fm.getTextWidth(line);
      g.drawText(line, (width-textWidth)/2, y);
      y += textHeight;
    }
  }

  /** Paints the black screen, and possibly the About message. */
  public void onPaint(Graphics g)
  {
    g.setColor(0, 0, 0);
    g.fillRect(0, 0, width, height);
    if(showText)
    {
      g.setColor(255, 255, 255);
      centerText(g, messages[nextMessage++]);
      if(nextMessage >= messages.length) nextMessage = 0;
    }
  }
  
  /** A click will show or dismiss the About message. */
  public void onEvent(Event event)
  {
    if (event.type == PenEvent.PEN_UP) {
      showText = !showText;
      repaint();
    }
  }
}
